from pydantic import BaseModel

class CouponLocationBase(BaseModel):
    uniacid: int
    acid: int
    sid: int
    location_id: int
    business_name: str
    branch_name: str
    category: str
    province: str
    city: str
    district: str
    address: str
    longitude: str
    latitude: str
    telephone: str
    photo_list: str
    avg_price: int
    open_time: str
    recommend: str
    special: str
    introduction: str
    offset_type: int
    status: int
    message: str

class CouponLocationCreate(CouponLocationBase):
    pass

class CouponLocationUpdate(CouponLocationBase):
    pass

class CouponLocation(CouponLocationBase):
    id: int

    class Config:
        orm_mode = True